#!/usr/local/bin/perl

# to make sure our IGP doesnt have things that IPAnalyze doesnt know about

use lib ('/export/web/ipanalyze.example.com/data/lib');

use strict;
use DBI;
use Net::SMTP;
use IPAnalyze::Misc;
use IPAnalyze::IPmath;

my %cfg;
open(CONFIG, '/export/web/ipanalyze.example.com/data/ipanalyze.conf') || die "cannot open ipanalyze.conf: $!\n";
while(<CONFIG>){
   s/^(.*)\s*#.*/$1/;
   next if(/^$/);
   chomp;
   if(/^(\S+)\s*=>\s?(.+)/){
      $cfg{$1} = $2;
   }
}
close CONFIG;

my $misc = IPAnalyze::Misc->new();
my $ipmath = IPAnalyze::IPmath->new();

my $dbh = DBI->connect($cfg{d_dsn}, $cfg{d_dbun}, $cfg{d_dbpw}, {RaiseError => 1});

my $sql = 'SELECT id,netblock,cidr FROM parent_networks WHERE allow_use = 1';
my $sth = $dbh->prepare($sql);
$sth->execute;
while(my $row = $sth->fetchrow_arrayref){
	my @netblocks = $ipmath->get_netblocks($row->[1],$row->[2],30);

	my $skip=0;
	foreach my $netblock (@netblocks){	
		if($skip){
			#warn "skipping $netblock\n";
			$skip--;
			next;
		}
		# find out if netblock is used
		my $sqla = 'SELECT cidr FROM data WHERE netblock = ' . $dbh->quote($netblock);
		my $stha = $dbh->prepare($sqla);
		$stha->execute;
		my $rowa = $stha->fetchrow_arrayref;

		if($rowa->[0]){
			$skip = ((2 ** (30-$rowa->[0])) - 1);
		}else{
			my $code = $misc->check_igp($ipmath,$cfg{'igp_host'},$cfg{'igp_community'},$netblock,30);

			if($code){
				#print "$netblock/30 is good\n";
			}else{
				print "$netblock/30 is routed and unassigned.\n";
			}
		}
	}
}
